/*
function_synthesizer ver0.1 10/05/20 Yokota
*/

#include<stdio.h>
#include<io.h>
#include<interrupt.h>
#include"font_data.c"			//tHgf[^
#include"wave_data_12bit.c"		//sin waveg`f[^

//OLEDp
#define OCS 0x10
#define ORES 0x08
#define ODC 0x04

//錾
void clk_init(void);
void io_init(void);
void spi_init(void);
void dac_init(void);             
void vport_init(void);
void dma_init(void);
void event_init(void);
void tc_init(void);
void oled_cmd_out(unsigned char);
void oled_data_out(unsigned char);
void draw_disp(void);
//錾I

#include"draw_oled.h"

unsigned int cnt,tim_cnt;
unsigned int wave_data[257];
char mode[20];
unsigned char freq_set_num;
const unsigned int freq_set[15]={62500,312500,15625,7813,6250,3125,1563,781,625,313,156,78,63,31,15};


int main(void)
{
	unsigned int i,j;
	char disp[20];

	clk_init();
	io_init();				//IO
	spi_init();				//SPI
	vport_init();				//z|[g蓖ď
	dac_init();				//D/ARo[^
	tc_init();				//^C}JE^
	dma_init();				//DMA
	event_init();				//CxgVXe

	VPORT2_OUT=VPORT2_OUT|ORES;

	oled_cmd_out(0xaf);		//OLED̓dON
	oled_cmd_out(0xa4);		//OLED display mode nomal
	oled_cmd_out(0xa0);
	oled_cmd_out(0x30);

	fill(0);
	set_font_color(0x0c,0);

	freq_set_num=5;
	TCC0_PER=freq_set[freq_set_num];
		
	for(i=0;i<256;i++)		//sin_wavef[^Rs[
	{
		wave_data[i]=sin_wave[i];
	}

	PMIC_CTRL=0x07;				//Non-maskable Interrupt
	sei();					//荞݋

	sprintf(mode,"sinwave     ");
	oled_printf(mode,1,0);
	draw_disp();			//fBXvCɏo

	while(1)
	{
		VPORT0_OUT=VPORT1_IN; 
		draw_disp();		//fBXvCɏo
	}

	return(0);
}

ISR (TCC1_OVF_vect)			//TCC1I[ot[荞݁ivbVXCb`ǂݍݏj
{

	static unsigned int i,j;

	//gݒ
	if(VPORT1_IN==0xef)	
	{
		if(freq_set_num>=14)
			freq_set_num=14;
		else
			freq_set_num++;
	}
	else if(VPORT1_IN==0xdf)
	{
		if(freq_set_num<=0)
			freq_set_num=0;
		else
			freq_set_num--;
	}

	//o͔g`ݒ
	//g
	else if(VPORT1_IN==0xfe)	
	{
		for(i=0;i<=255;i++)	
		{
			wave_data[i]=sin_wave[i];
		}
		sprintf(mode,"sinwave     ");
	}

	//Opg
	else if(VPORT1_IN==0xfd)
	{
		j=0;
		for(i=0;i<=255;i++)
		{
			wave_data[i]=j;
			if(i>0x7f)
				j=j-31;
			else
				j=j+31;
		}
		sprintf(mode,"triangle     ");
	}
	//g
	else if(VPORT1_IN==0xfb)
	{
		j=0;
		for(i=0;i<=255;i++)
		{
			j=j+15;
			wave_data[i]=j;
		}
		sprintf(mode,"sawtooth     ");
	}
	//gi]j
	else if(VPORT1_IN==0xf7)
	{
		j=3840;
		for(i=0;i<=255;i++)
		{
			j=j-15;
			wave_data[i]=j;
		}
		sprintf(mode,"inv sawtooth ");
	}

	TCC0_PER=freq_set[freq_set_num];	//TCC0Ɏgݒ


}

void clk_init(void)
{
	OSC_CTRL=0x03;				//32MHzNbNL
	while(OSC_STATUS!=0x03);		//肷܂ő҂
	CCP=0xd8;				//ی@\
	CLK_CTRL=0x01;				//sysclk32MHzɕύX
	OSC_CTRL=0x02;				//2MHzNbN~
}

void io_init(void)
{
	PORTA_DIRSET=0xff;	//PORTAo
	PORTE_DIRSET=0xff;	//PORTEo
	PORTD_DIRSET=0xff;	//PORTDo

	PORTF_PIN0CTRL=0x38;	//vAbv
	PORTF_PIN1CTRL=0x38;
	PORTF_PIN2CTRL=0x38;
	PORTF_PIN3CTRL=0x38;
	PORTF_PIN4CTRL=0x38;
	PORTF_PIN5CTRL=0x38;
	PORTF_PIN6CTRL=0x38;
	PORTF_PIN7CTRL=0x38;
	PORTF_OUT=0xff;		//PORTFvAbvANeBu

}

void spi_init(void)
{
	SPID_CTRL=0b01010000; //SCK=clk/4
}

void dac_init(void)
{
	DACA_CTRLA=0x05;	//DAC ch0 enableCDAC enable
	DACA_CTRLC=0x08;	//DACdAVCC
	DACA_TIMCTRL=0x5f;	//DAC_CLK=clk(32MHz)/32=1MHzCXVs
}
	
void vport_init(void)
{
	PORTCFG_VPCTRLA=0x54;	//PORTEVPORT0蓖āCPORTFVPORT1蓖
	PORTCFG_VPCTRLB=0x03;	//PORTDVPORT2蓖
}

void dma_init(void)
{
	uint32_t temp;

	temp=&wave_data;			//g`f[^i[z̃|C^Rs[
	DMA_CH0_SRCADDR0=(char)temp;		//DMA Ch0̃f[^]ɐݒ
	DMA_CH0_SRCADDR1=(char)(temp>>8);	
	DMA_CH0_SRCADDR2=(char)(temp>>16);

	temp=&DACA_CH0DATA;			//D-ARo[^̃f[^WX^̃|C^Rs[
	DMA_CH0_DESTADDR0=(char)temp;		//DMA Ch0̃f[^]ɐݒ
	DMA_CH0_DESTADDR1=(char)(temp>>8);
	DMA_CH0_DESTADDR2=(char)(temp>>16);

	DMA_CH0_ADDRCTRL=0xd9;			//Pʓ]f[^]AhXZbgC]AhXZCo[Xg]f[^]AhXZbgC]AhXZC
	DMA_CH0_TRIGSRC=0x01;			//TRIGSRCEvent system ch0ɐݒ
	DMA_CH0_REPCNT=0;			//s[g
	
	DMA_CH0_TRFCNT=512;			//Pʓ]

	DMA_CH0_CTRLA=0xa5;			//DMA_CH0Csingle shotC2BYTEo[Xg]
	DMA_CTRL=0x81;				//DMACCH0ŗD
}

void event_init(void)
{
	EVSYS_CH0MUX=0xc0;		//EVSYS Ch016rbgE^C}0 I[o[t[ɐݒ
}

void tc_init(void)
{
	TCC0_CTRLA=0x02;		//CLKSEL=clk/2=16MHz
	TCC0_PER=64300;

	TCC1_CTRLA=0x05;		//CLKSEL=clk/64
	TCC1_INTCTRLA=0x02;		//I[o[t[荞݋
	TCC1_PER=0xffff;
}

void oled_cmd_out(unsigned char data)
{	
	VPORT2_OUT=VPORT2_OUT&(~ODC)&(~OCS);	//DCyCSLowɂ
	SPID_DATA=data;				//SPIf[^M
	while(SPID_STATUS!=0x80);		//obt@ɂȂ܂ő҂
	VPORT2_OUT=VPORT2_OUT|ODC|OCS;		//DCyCSHighɂ
}

void oled_data_out(unsigned char data)
{
	VPORT2_OUT=VPORT2_OUT&(~OCS);		//CSLowɂ
	SPID_DATA=data;				//SPIf[^M
	while(SPID_STATUS!=0x80);		//obt@ɂȂ܂ő҂
	VPORT2_OUT=VPORT2_OUT|OCS;		//CSHighɂ
}

void draw_disp(void)
{
	unsigned int i,j,k;
	unsigned char ad_temp;
	char disp[20];
	unsigned int freq_num[15]={1,2,4,8,10,20,40,80,100,200,400,800,1000,2000,4000};
	
	oled_printf(mode,1,0);					//݂̏o͔g`\
	sprintf(disp,"Freq:%4dHz",freq_num[freq_set_num]);	//݂̎g\
	oled_printf(disp,1,8);

	oled_cmd_out(0xa0);
	oled_cmd_out(0x31);

	k=2;
	while(k--)	//g`̃OtBbNC[W\
	{
		oled_cmd_out(0x15);	//Column Addr
		oled_cmd_out(0);
		oled_cmd_out(95);

		oled_cmd_out(0x75);	//Row Addr
		oled_cmd_out(17);
		oled_cmd_out(63);

		for(i=0;i<86;i++)	//x
		{
			for(j=0;j<47;j++)	//y
			{
				if(i<43)
					ad_temp=40-(wave_data[i*6]>>7);
				else
					ad_temp=40-(wave_data[(i-43)*6]>>7);
				if(j==ad_temp)
					oled_data_out(0x0d);
				else	
					oled_data_out(0x00);
			}
		}
	}

	oled_cmd_out(0xa0);
	oled_cmd_out(0x30);
}
